com.io7m.r2.core

## Interface R2SceneOpaquesType

- All Superinterfaces:
    R2SceneOpaquesReadableType
  All Known Implementing Classes:
    R2SceneOpaques

      public interface R2SceneOpaquesType
      extends R2SceneOpaquesReadableType

  The set of opaque instances in a scene.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default <M> void` | `opaquesAddBatchedInstance(R2InstanceBatchedType i, R2MaterialOpaqueBatchedType<M> m)` Add a batched instance to the scene using the given material, in group `1`.
    `<M> void` | `opaquesAddBatchedInstanceInGroup(R2InstanceBatchedType i, R2MaterialOpaqueBatchedType<M> m, int group)` Add a batched instance to the scene using the given material.
    `default <M> void` | `opaquesAddBillboardedInstance(R2InstanceBillboardedType i, R2MaterialOpaqueBillboardedType<M> m)` Add a billboarded instance to the scene using the given material, in group `1`.
    `<M> void` | `opaquesAddBillboardedInstanceInGroup(R2InstanceBillboardedType i, R2MaterialOpaqueBillboardedType<M> m, int group)` Add a billboarded instance to the scene using the given material.
    `default <M> void` | `opaquesAddSingleInstance(R2InstanceSingleType i, R2MaterialOpaqueSingleType<M> m)` Add a single instance to the scene using the given material, in group `1`.
    `<M> void` | `opaquesAddSingleInstanceInGroup(R2InstanceSingleType i, R2MaterialOpaqueSingleType<M> m, int group)` Add a single instance to the scene using the given material.
    `void` | `opaquesReset()` Remove all instances from the scene.

    - ### Methods inherited from interface com.io7m.r2.core.R2SceneOpaquesReadableType

      `opaquesCount, opaquesExecute`

- - ### Method Detail

    - #### opaquesReset

          void opaquesReset()

      Remove all instances from the scene.

    - #### opaquesAddSingleInstance

          default <M> void opaquesAddSingleInstance(R2InstanceSingleType i,
                                                    R2MaterialOpaqueSingleType<M> m)

      Add a single instance to the scene using the given material, in group `1`.
      Type Parameters:
        `M` - The type of shader parameters
      Parameters:
        `i` - The instance
        `m` - The material

    - #### opaquesAddSingleInstanceInGroup

          <M> void opaquesAddSingleInstanceInGroup(R2InstanceSingleType i,
                                                   R2MaterialOpaqueSingleType<M> m,
                                                   int group)

      Add a single instance to the scene using the given material. The instance is placed into the specified `group`, which must be a value in the range `[1, {@link R2Stencils#MAXIMUM_GROUPS}]`.
      Type Parameters:
        `M` - The type of shader parameters
      Parameters:
        `i` - The instance
        `m` - The material
        `group` - The group

    - #### opaquesAddBatchedInstance

          default <M> void opaquesAddBatchedInstance(R2InstanceBatchedType i,
                                                     R2MaterialOpaqueBatchedType<M> m)

      Add a batched instance to the scene using the given material, in group `1`.
      Type Parameters:
        `M` - The type of shader parameters
      Parameters:
        `i` - The instance
        `m` - The material

    - #### opaquesAddBatchedInstanceInGroup

          <M> void opaquesAddBatchedInstanceInGroup(R2InstanceBatchedType i,
                                                    R2MaterialOpaqueBatchedType<M> m,
                                                    int group)

      Add a batched instance to the scene using the given material. The instance is placed into the specified `group`, which must be a value in the range `[1, 127]`.
      Type Parameters:
        `M` - The type of shader parameters
      Parameters:
        `i` - The instance
        `m` - The material
        `group` - The group

    - #### opaquesAddBillboardedInstance

          default <M> void opaquesAddBillboardedInstance(R2InstanceBillboardedType i,
                                                         R2MaterialOpaqueBillboardedType<M> m)

      Add a billboarded instance to the scene using the given material, in group `1`.
      Type Parameters:
        `M` - The type of shader parameters
      Parameters:
        `i` - The instance
        `m` - The material

    - #### opaquesAddBillboardedInstanceInGroup

          <M> void opaquesAddBillboardedInstanceInGroup(R2InstanceBillboardedType i,
                                                        R2MaterialOpaqueBillboardedType<M> m,
                                                        int group)

      Add a billboarded instance to the scene using the given material. The instance is placed into the specified `group`, which must be a value in the range `[1, 127]`.
      Type Parameters:
        `M` - The type of shader parameters
      Parameters:
        `i` - The instance
        `m` - The material
        `group` - The group

Copyright © 2017 <code@io7m.com> http://io7m.com